﻿using System.Collections.Generic;
using static UnityEngine.XR.OpenXR.Features.HisSupport.HisHandDll;

namespace UnityEngine.XR.OpenXR.Features.HisSupport
{
    public class HisHandPoseGenerator : MonoBehaviour
    {
        public HisHandPoseConfig config;
        public HisHandPosePreview preview;
        //Shapes
        public ShapesRecognizer.Finger thumb = new ShapesRecognizer.Finger(HisHandDll.HandFinger.Thumb);
        public ShapesRecognizer.Finger index = new ShapesRecognizer.Finger(HisHandDll.HandFinger.Index);
        public ShapesRecognizer.Finger middle = new ShapesRecognizer.Finger(HisHandDll.HandFinger.Middle);
        public ShapesRecognizer.Finger ring = new ShapesRecognizer.Finger(HisHandDll.HandFinger.Ring);
        public ShapesRecognizer.Finger pinky = new ShapesRecognizer.Finger(HisHandDll.HandFinger.Pinky);

        public float shapesholdDuration = 0.09f;

        //Bones
        public List<BonesRecognizer.BonesGroup> Bones = new List<BonesRecognizer.BonesGroup>();

        public float bonesHoldDuration = 0.022f;

        //Trans
        public TransRecognizer.TrackAxis trackAxis;
        public TransRecognizer.SpaceType spaceType;
        public TransRecognizer.TrackTarget trackTarget;

        public float angleThreshold = 35f;
        public float thresholdWidth = 10f;
        public float transHoldDuration = 0.022f;
    }
}