using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR.OpenXR.Features.HisSupport;

namespace Unity.XR.HisenseXR.Samples
{
    public class HisInputHandSample : MonoBehaviour
    {
        public Text tipText;

        public Toggle handToggle;
        public Toggle okToggle;

        public Toggle goodToggle;

        public HisHandPose okHandPos;
        public HisHandPose goodHandPos;

        private void Start()
        {
            okHandPos.gameObject.SetActive(false);
            goodHandPos.gameObject.SetActive(true);

            handToggle.onValueChanged.AddListener(m =>
            {
                HisHandManager.Instance.isHandOn = m;
                if (m)
                {
                    Debug.Log("StartHandTrack");
                    HisHandManager.Instance.StartHandTrack();
                }
                else
                {
                    Debug.Log("StopHandTrack");
                    HisHandManager.Instance.StopHandTrack();
                }
            });
            okToggle.onValueChanged.AddListener(m =>
            {
                okHandPos.gameObject.SetActive(m);
                goodHandPos.gameObject.SetActive(!m);
            });
            goodToggle.onValueChanged.AddListener(m =>
            {
                okHandPos.gameObject.SetActive(!m);
                goodHandPos.gameObject.SetActive(m);
            });
        }

        public void DisplayCallBackInfo(string info)
        {
            tipText.text = info;
        }

        public void Quit()
        {
            Application.Quit();
        }
    }
}